(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('conflux-web-core-helpers'), require('conflux-web-utils'), require('@babel/runtime/helpers/classCallCheck'), require('@babel/runtime/helpers/possibleConstructorReturn'), require('@babel/runtime/helpers/getPrototypeOf'), require('@babel/runtime/helpers/inherits'), require('conflux-web-core-method'), require('@babel/runtime/regenerator'), require('@babel/runtime/helpers/asyncToGenerator'), require('@babel/runtime/helpers/createClass'), require('conflux-web-core'), require('lodash/isFunction')) :
    typeof define === 'function' && define.amd ? define(['exports', 'conflux-web-core-helpers', 'conflux-web-utils', '@babel/runtime/helpers/classCallCheck', '@babel/runtime/helpers/possibleConstructorReturn', '@babel/runtime/helpers/getPrototypeOf', '@babel/runtime/helpers/inherits', 'conflux-web-core-method', '@babel/runtime/regenerator', '@babel/runtime/helpers/asyncToGenerator', '@babel/runtime/helpers/createClass', 'conflux-web-core', 'lodash/isFunction'], factory) :
    (global = global || self, factory(global.ConfluxWebNet = {}, global.confluxWebCoreHelpers, global.Utils, global._classCallCheck, global._possibleConstructorReturn, global._getPrototypeOf, global._inherits, global.confluxWebCoreMethod, global._regeneratorRuntime, global._asyncToGenerator, global._createClass, global.confluxWebCore, global.isFunction));
}(this, function (exports, confluxWebCoreHelpers, Utils, _classCallCheck, _possibleConstructorReturn, _getPrototypeOf, _inherits, confluxWebCoreMethod, _regeneratorRuntime, _asyncToGenerator, _createClass, confluxWebCore, isFunction) { 'use strict';

    _classCallCheck = _classCallCheck && _classCallCheck.hasOwnProperty('default') ? _classCallCheck['default'] : _classCallCheck;
    _possibleConstructorReturn = _possibleConstructorReturn && _possibleConstructorReturn.hasOwnProperty('default') ? _possibleConstructorReturn['default'] : _possibleConstructorReturn;
    _getPrototypeOf = _getPrototypeOf && _getPrototypeOf.hasOwnProperty('default') ? _getPrototypeOf['default'] : _getPrototypeOf;
    _inherits = _inherits && _inherits.hasOwnProperty('default') ? _inherits['default'] : _inherits;
    _regeneratorRuntime = _regeneratorRuntime && _regeneratorRuntime.hasOwnProperty('default') ? _regeneratorRuntime['default'] : _regeneratorRuntime;
    _asyncToGenerator = _asyncToGenerator && _asyncToGenerator.hasOwnProperty('default') ? _asyncToGenerator['default'] : _asyncToGenerator;
    _createClass = _createClass && _createClass.hasOwnProperty('default') ? _createClass['default'] : _createClass;
    isFunction = isFunction && isFunction.hasOwnProperty('default') ? isFunction['default'] : isFunction;

    var MethodFactory =
    function (_AbstractMethodFactor) {
      _inherits(MethodFactory, _AbstractMethodFactor);
      function MethodFactory(utils, formatters) {
        var _this;
        _classCallCheck(this, MethodFactory);
        _this = _possibleConstructorReturn(this, _getPrototypeOf(MethodFactory).call(this, utils, formatters));
        _this.methods = {
          getId: confluxWebCoreMethod.VersionMethod,
          getBlockByNumber: confluxWebCoreMethod.GetBlockByNumberMethod,
          isListening: confluxWebCoreMethod.ListeningMethod,
          getPeerCount: confluxWebCoreMethod.PeerCountMethod
        };
        return _this;
      }
      return MethodFactory;
    }(confluxWebCoreMethod.AbstractMethodFactory);

    var Network =
    function (_AbstractConfluxWebMo) {
      _inherits(Network, _AbstractConfluxWebMo);
      function Network(provider, methodFactory, utils, formatters, options, nodeNet) {
        var _this;
        _classCallCheck(this, Network);
        _this = _possibleConstructorReturn(this, _getPrototypeOf(Network).call(this, provider, options, methodFactory, nodeNet));
        _this.utils = utils;
        _this.formatters = formatters;
        return _this;
      }
      _createClass(Network, [{
        key: "getNetworkType",
        value: function () {
          var _getNetworkType = _asyncToGenerator(
          _regeneratorRuntime.mark(function _callee(callback) {
            var id, networkType;
            return _regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _context.prev = 0;
                    _context.next = 3;
                    return this.getId();
                  case 3:
                    id = _context.sent;
                    networkType = 'private';
                    _context.t0 = id;
                    _context.next = _context.t0 === 1 ? 8 : _context.t0 === 2 ? 10 : _context.t0 === 3 ? 12 : _context.t0 === 4 ? 14 : _context.t0 === 42 ? 16 : 18;
                    break;
                  case 8:
                    networkType = 'main';
                    return _context.abrupt("break", 18);
                  case 10:
                    networkType = 'morden';
                    return _context.abrupt("break", 18);
                  case 12:
                    networkType = 'ropsten';
                    return _context.abrupt("break", 18);
                  case 14:
                    networkType = 'rinkeby';
                    return _context.abrupt("break", 18);
                  case 16:
                    networkType = 'kovan';
                    return _context.abrupt("break", 18);
                  case 18:
                    if (isFunction(callback)) {
                      callback(null, networkType);
                    }
                    return _context.abrupt("return", networkType);
                  case 22:
                    _context.prev = 22;
                    _context.t1 = _context["catch"](0);
                    if (isFunction(callback)) {
                      callback(_context.t1, null);
                    }
                    throw _context.t1;
                  case 26:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee, this, [[0, 22]]);
          }));
          function getNetworkType(_x) {
            return _getNetworkType.apply(this, arguments);
          }
          return getNetworkType;
        }()
      }]);
      return Network;
    }(confluxWebCore.AbstractConfluxWebModule);

    function Network$1(provider) {
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      return new Network(provider, new MethodFactory(Utils, confluxWebCoreHelpers.formatters), Utils, confluxWebCoreHelpers.formatters, options, null);
    }

    exports.Network = Network$1;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
